theory HL_setup
imports Hoare_Logic
begin


lemmas AssignRule = BasicRule

lemma CondRule' :
"Valid (P \<inter> C) p Q \<Longrightarrow> Valid (P \<inter> -C) q Q \<Longrightarrow>
 Valid P (IF C THEN p ELSE q FI) Q"
  by(rule CondRule[rotated 1], assumption+, fast)

lemma SeqRule': 
"Valid Q c2 R \<Longrightarrow> Valid P c1 Q \<Longrightarrow> Valid P (c1;c2) R"
  by(simp add: SeqRule)


lemma ConseqRule : 
"Valid P p Q \<Longrightarrow> P' \<subseteq> P \<Longrightarrow> Q \<subseteq> Q' \<Longrightarrow> Valid P' p Q'"
  by(simp add: Valid_def, fast)



lemma two :
"2 * (a :: int) = 2 * b \<Longrightarrow> a = b"
  by simp


lemma even_pow :
"even n \<Longrightarrow> (a * a)^(n div 2) = (a::int)^n"
  apply(induct n rule: less_induct)
  apply(case_tac "x=0", simp)
  apply(drule_tac x="x - 2" in meta_spec)
  apply(drule meta_mp, simp)+
  apply(case_tac x, simp)
  apply(rename_tac z)
  apply(case_tac z, simp)
  apply simp
  done


lemmas mult_assoc = mult.assoc[THEN sym]
lemmas mult_commute = mult.commute

end